/*
 *	Copyright (C) 1999 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: a.c,v 1.2 2000/11/09 01:50:31 nis Exp $"; */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

#include <geta/cpipe.h>
#include "filters.h"

static void usage(void);

char *progname;

static void
usage()
{
	fprintf(stderr, "usage: %s\n", progname);
	exit(1);
}

main(argc, argv)
char *argv[];
{
	struct cpipe_filter *filter;
	static struct cpipe_config_entry conf[] = {
		{"reverse", FT_STRING, NULL, cpipe_reverse_filt},
		{"split", FT_VECTOR, cpipe_split_init, cpipe_split_filt},
		{NULL, 0, NULL, NULL},
	};

	if (progname = rindex(argv[0], '/')) {
		progname++;
	}
	else {
		progname = argv[0];
	}
	for (argc--, argv++; argc>0; argc--, argv++) {
		if (!strcmp(*argv, "-h")) {
			usage();
			exit(1);
		}
		else {
			break;
		}
	}
	if (argc!=0) {
		usage();
	}

	if (!(filter = cpipe_setup_filter(conf, NULL))) {
		exit(1);
	}

	cpipe_main_loop(filter);

	exit(0);
}
