/*
 *	Copyright (C) 1999 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: filters.c,v 1.4 2001/09/06 06:23:20 nis Exp $"; */

#include <sys/types.h>
#include <sys/uio.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <geta/getamu.h>

#include "filters.h"

int
cpipe_reverse_filt(cookie, input, output)
void *cookie;
char *input;
void **output;
{
	int i, j;
	if (!input) {
		return 0;
	}
	j = strlen(input);
	for (i=0, j=strlen(input)-1; i<j; i++, j--) {
		char t;
		t = input[i];
		input[i] = input[j];
		input[j] = t;
	}
	*output = input;
	return 1;
}

#define	CPIPE_SPLIT_BUFLEN	128

void *
cpipe_split_init(arg)
char *arg;
{
fprintf(stderr, "arg=[%s]\n", arg?arg:"(null)");
	return malloc(CPIPE_SPLIT_BUFLEN * sizeof(char **));
}

int
cpipe_split_filt(cookie, input, output)
void *cookie;
char *input;
void **output;
{
	char **v;
	int e;

	v = cookie;
	if (!input) {
		return 0;
	}
	e = splitv(input, " \t\n", v, CPIPE_SPLIT_BUFLEN);
	*output = v;
	return e;
}
