/*
 *	Copyright (C) 1998 Advanced Research Laboratory, Hitachi, Ltd.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: ztoh.c,v 1.5 2001/09/06 06:23:21 nis Exp $"; */

#include <sys/types.h>

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include <geta/getamu.h>
#include <geta/srvmu.h>
#include <geta/iso2022jp2.h>
#include <geta/jis.h>

#define	BUFLENINC	8192

char *progname;

main(argc, argv)
char *argv[];
{
	char *p, *q;
	int qlen;

	if (progname = rindex(argv[0], '/')) {
		progname++;
	}
	else {
		progname = argv[0];
	}

	qlen = BUFLENINC;
	if (!(q = malloc(qlen))) {
		perror("malloc");
		exit(1);
	}

	for (; p = freadln(stdin); ) {
		int l, e;
		l = ztohs(p, NULL)+1;
		if (l>=qlen) {
			qlen = bndry(l, BUFLENINC);
			if (!(q = realloc(q, qlen))) {
				perror("realloc");
				exit(1);
			}
		}
		e = ztohs(p, q)+1;
		assert(l==e);
		if (strlen(q)>qlen) {
			fprintf(stderr, "too long!, %d, %d\n", qlen, strlen(q));
			exit(1);
		}
		fputs(q, stdout);
		fflush(stdout);
	}
	return 0;
}
