/*
 *	Copyright (C) 1998 Advanced Research Laboratory, Hitachi, Ltd.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: do_split.c,v 1.5 2001/09/06 06:23:21 nis Exp $"; */

#include <sys/types.h>

#include <ctype.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <syslog.h>

#include <geta/getamu.h>
#include <geta/srvmu.h>
#include <geta/smap.h>

#include "ssP.h"

extern int errno;

#if 0
static void
sig(n)
{
	syslog(LOG_ERR, "do_split: caught a signal %d", n);
	exit(1);
}
#endif

void
do_split()
{
	char *p;
	static char *buf = NULL;
#if 0
	int i;
#endif

/*
	openlog("do_split", LOG_PID, LOG_LOCAL1);
*/
#if 0
	for (i=0; i<32; i++) {
		signal(i, sig);
	}
#endif
	if (!buf && !(buf = malloc(IBUFSIZE))) {
		perror("malloc");
		return;
	}
	while (fgets(buf, IBUFSIZE, stdin)) {
		chop(buf);
		for (p=buf; *p; ) {
			char *q;
			while (*p && isspace(*p) || *p==CSEP) {
				if (*p==CSEP)
					fprintf(stdout, "%c %c" CRLF, *p, *p);
				p++;
			}
			if (!*p) break;
			for (q = p; *q && !isspace(*q); q++) ;
			if (*q) *q++ = '\0';
			fprintf(stdout, "%s %s" CRLF, p, p);
			p = q;
		}
		fflush(stdout);
	}
	syslog(LOG_ERR, "do_split: fgets failed: %s", strerror(errno));
}
