/*
 *	Copyright (C) 1998 Advanced Research Laboratory, Hitachi, Ltd.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: uniform.c,v 1.7 2001/09/06 06:23:21 nis Exp $"; */

#include <sys/types.h>

#include <stdio.h>
#include <unistd.h>

#include <geta/getamu.h>
#include <geta/srvmu.h>
#include <geta/smap.h>
#include "ssP.h"

int
split1(buf, n, s0)
char *buf, *s0;
size_t n;
{
	char *s1, *rest;
	split(s0, " ", &s1, &rest, (char **)NULL);
	if (s1 && *s1==CSEP) {
		return 1;
	}
	if (s1) {
		snprintf(buf, n, "%s %s", s1, s1);
		return 0;
	}
	return -1;
}

int
splitn(buf, n, s0)
char *buf, *s0;
size_t n;
{
	char *s1, *s2, *rest;
	split(s0, " ", &s1, &s2, &rest, (char **)NULL);
	if (s1 && *s1==CSEP) {
		return 1;
	}
	if (s1 && s2) {
		snprintf(buf, n, "%s %s", s1, s2);
		return 0;
	}
	return -1;
}

int
stemn(buf, n, s0)
char *buf, *s0;
size_t n;
{
	char *s1, *s2, *s3, *rest;
	split(s0, " ", &s1, &s2, &s3, &rest, (char **)NULL);
	if (s1 && *s1==CSEP) {
		return 1;
	}
	if (s1 && s2 && s3) {	/* we must check s2!=NULL explicitly */
		snprintf(buf, n, "%s %s", s1, s3);
		return 0;
	}
	return -1;
}

int
chasenn(buf, n, s0)
char *buf, *s0;
size_t n;
{
	char *s1, *s2, *s3, *rest;
	split(s0, "\t", &s1, &s2, &s3, &rest, (char **)NULL);
	if (s1 && *s1==CSEP) {
		return 1;
	}
	if (s1 && s2 && s3) {	/* we must check s2!=NULL explicitly */
		snprintf(buf, n, "%s %s", s1, s3);
		return 0;
	}
	return -1;
}

int
ngramn(buf, n, s0)
char *buf, *s0;
size_t n;
{
	char *s1, *rest;
	split(s0, " ", &s1, &rest, (char **)NULL);
	if (s1 && *s1==CSEP) {
		return 1;
	}
	if (s1) {
		snprintf(buf, n, "%s %s", s1, s1);
		return 0;
	}
	return -1;
}

int
animar(buf, n, s0)
char *buf, *s0;
size_t n;
{
	char *s1, *s2, *s3, *rest;
	split(s0, " ", &s1, &s2, &s3, &rest, (char **)NULL);
	if (s1 && *s1==CSEP) {
		return 1;
	}
	if (s1 && s2 && s3) {
		snprintf(buf, n, "%s %s", s1, s2);
		return 0;
	}
	return -1;
}

/* transparent filter */
int
def_filt(buf, n, s0)
char *buf, *s0;
size_t n;
{
	if (*s0==CSEP) {
		return 1;
	}
	scopy(s0, buf, n);
	return 0;
}
